diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iofdopen.c libg++-2.5.3linux.2/libio/iofdopen.c
*** libg++-2.5.3/libio/iofdopen.c	Fri Nov 26 21:58:48 1993
--- libg++-2.5.3linux.2/libio/iofdopen.c	Mon Dec 20 08:54:26 1993
***************
*** 23,28 ****
--- 23,33 ----
  the executable file might be covered by the GNU General Public License. */
  
  #include "libioP.h"
+ #include <fcntl.h>
+ 
+ #ifndef _IO_fcntl
+ #define _IO_fcntl fcntl
+ #endif
  
  _IO_FILE *
  _IO_fdopen (fd, mode)
***************
*** 30,35 ****
--- 35,42 ----
       const char *mode;
  {
    int read_write;
+   int posix_mode = 0;
+   int status_flag;
    struct _IO_FILE_plus *fp;
  
    switch (*mode++)
***************
*** 41,46 ****
--- 48,54 ----
        read_write = _IO_NO_READS;
        break;
      case 'a':
+       posix_mode = O_APPEND;
        read_write = _IO_NO_READS|_IO_IS_APPENDING;
        break;
      default:
***************
*** 65,75 ****
--- 73,107 ----
        free (fp);
        return NULL;
      }
+   fp->_file._flags |= CLOSED_FILEBUF_FLAGS;
    fp->_file._flags &= ~_IO_DELETE_DONT_CLOSE;
  
    fp->_file._IO_file_flags = 
      _IO_mask_flags(&fp->_file, read_write,
  		   _IO_NO_READS+_IO_NO_WRITES+_IO_IS_APPENDING);
  
+ #ifdef F_GETFL
+   status_flag = _IO_fcntl (fp->_file._fileno, F_GETFL);
+   if (status_flag == -1)
+   {
+     _IO_un_link(&fp->_file);
+     free (fp);
+     return NULL;
+   }
+   /* check if we need to change the status flag. */
+   if ((status_flag & O_APPEND) != posix_mode)
+   {
+     /* Set new status flag. */
+     status_flag = (status_flag & ~O_APPEND) | posix_mode;
+     if (_IO_fcntl (fp->_file._fileno, F_SETFL, status_flag) == -1)
+     {
+       _IO_un_link(&fp->_file);
+       free (fp);
+       return NULL;
+     }
+   }
+ #else
+ #error "I don't know what you have for F_GETFL."
+ #endif
    return (_IO_FILE*)fp;
  }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iofflush.c libg++-2.5.3linux.2/libio/iofflush.c
*** libg++-2.5.3/libio/iofflush.c	Fri Aug 20 04:18:06 1993
--- libg++-2.5.3linux.2/libio/iofflush.c	Sun Feb 13 22:30:10 1994
***************
*** 32,37 ****
--- 32,38 ----
      return _IO_flush_all();
    else
      {
+       CHECK_FILE(fp, EOF);
        COERCE_FILE(fp);
        return fp->_jumps->__sync(fp) ? EOF : 0;
      }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iofgetpos.c libg++-2.5.3linux.2/libio/iofgetpos.c
*** libg++-2.5.3/libio/iofgetpos.c	Mon Sep 27 17:46:25 1993
--- libg++-2.5.3linux.2/libio/iofgetpos.c	Sun Feb 13 22:30:23 1994
***************
*** 32,37 ****
--- 32,38 ----
       _IO_fpos_t *posp;
  {
    _IO_fpos_t pos;
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    pos = _IO_seekoff(fp, 0, _IO_seek_cur|_IO_seek_not_in|_IO_seek_not_out);
    if (pos == _IO_pos_BAD)
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iofgets.c libg++-2.5.3linux.2/libio/iofgets.c
*** libg++-2.5.3/libio/iofgets.c	Fri Aug 20 04:18:07 1993
--- libg++-2.5.3linux.2/libio/iofgets.c	Mon Feb 14 09:52:18 1994
***************
*** 30,39 ****
       int n;
       _IO_FILE* fp;
  {
!   long count;
    COERCE_FILE(fp);
!   count = _IO_getline(fp, buf, n, '\n', 1);
!   if (count <= 0)
      return NULL;
    return buf;
  }
--- 30,43 ----
       int n;
       _IO_FILE* fp;
  {
!   _IO_size_t count;
!   CHECK_FILE(fp, NULL);
    COERCE_FILE(fp);
!   if (n <= 0)
      return NULL;
+   count = _IO_getline(fp, buf, n - 1, '\n', 1);
+   if (count == 0 || (fp->_IO_file_flags & _IO_ERR_SEEN))
+     return NULL;
+   buf[count] = 0;
    return buf;
  }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iofopen.c libg++-2.5.3linux.2/libio/iofopen.c
*** libg++-2.5.3/libio/iofopen.c	Fri Nov 26 17:01:56 1993
--- libg++-2.5.3linux.2/libio/iofopen.c	Mon Dec 20 08:54:27 1993
***************
*** 23,29 ****
  the executable file might be covered by the GNU General Public License. */
  
  #include "libioP.h"
- #include <stdlib.h>
  
  _IO_FILE *
  _IO_fopen (filename, mode)
--- 23,28 ----
***************
*** 37,44 ****
    _IO_init(&fp->_file, 0);
    fp->_file._jumps = &_IO_file_jumps;
    _IO_file_init(&fp->_file);
-   if (fp == NULL)
-     return NULL;
    fp->_vtable = NULL;
    if (_IO_file_fopen(&fp->_file, filename, mode) != NULL)
          return (_IO_FILE*)fp;
--- 36,41 ----
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iofprintf.c libg++-2.5.3linux.2/libio/iofprintf.c
*** libg++-2.5.3/libio/iofprintf.c	Tue Oct  5 13:39:41 1993
--- libg++-2.5.3linux.2/libio/iofprintf.c	Mon Feb 14 09:59:35 1994
***************
*** 40,45 ****
--- 40,46 ----
  {
    int ret;
    va_list args;
+   CHECK_FILE(fp, -1);
    COERCE_FILE(fp);
    _IO_va_start(args, format);
    ret = _IO_vfprintf(fp, format, args);
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iofputs.c libg++-2.5.3linux.2/libio/iofputs.c
*** libg++-2.5.3/libio/iofputs.c	Fri Nov 26 17:01:57 1993
--- libg++-2.5.3linux.2/libio/iofputs.c	Mon Feb 14 09:59:47 1994
***************
*** 30,35 ****
--- 30,36 ----
       _IO_FILE *fp;
  {
    _IO_size_t len = strlen(str);
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    if (_IO_sputn(fp, str, len) != len)
      return EOF;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iofread.c libg++-2.5.3linux.2/libio/iofread.c
*** libg++-2.5.3/libio/iofread.c	Wed Dec 22 06:39:59 1993
--- libg++-2.5.3linux.2/libio/iofread.c	Mon Feb 14 10:09:53 1994
***************
*** 33,38 ****
--- 33,39 ----
  {
    _IO_size_t bytes_requested = size*count;
    _IO_size_t bytes_read;
+   CHECK_FILE(fp, 0);
    COERCE_FILE(fp);
    if (bytes_requested == 0)
      return 0;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iofscanf.c libg++-2.5.3linux.2/libio/iofscanf.c
*** libg++-2.5.3/libio/iofscanf.c	Wed Nov  3 14:59:49 1993
--- libg++-2.5.3linux.2/libio/iofscanf.c	Mon Feb 14 10:02:22 1994
***************
*** 40,45 ****
--- 40,46 ----
  {
    int ret;
    va_list args;
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    _IO_va_start(args, format);
    ret = _IO_vfscanf(fp, format, args, NULL);
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iofsetpos.c libg++-2.5.3linux.2/libio/iofsetpos.c
*** libg++-2.5.3/libio/iofsetpos.c	Wed Dec 22 06:40:00 1993
--- libg++-2.5.3linux.2/libio/iofsetpos.c	Sun Feb 13 22:31:02 1994
***************
*** 30,35 ****
--- 30,36 ----
       _IO_FILE* fp;
       const _IO_fpos_t *posp;
  {
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    if (_IO_seekpos(fp, *posp, 0) == _IO_pos_BAD)
      {
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/ioftell.c libg++-2.5.3linux.2/libio/ioftell.c
*** libg++-2.5.3/libio/ioftell.c	Fri Aug 20 04:18:11 1993
--- libg++-2.5.3linux.2/libio/ioftell.c	Sun Feb 13 22:26:42 1994
***************
*** 31,36 ****
--- 31,37 ----
       _IO_FILE* fp;
  {
    _IO_pos_t pos;
+   CHECK_FILE(fp, -1L);
    COERCE_FILE(fp);
    pos = _IO_seekoff(fp, 0, _IO_seek_cur|_IO_seek_not_in|_IO_seek_not_out);
    if (pos == _IO_pos_BAD)
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iofwrite.c libg++-2.5.3linux.2/libio/iofwrite.c
*** libg++-2.5.3/libio/iofwrite.c	Wed Dec 22 06:40:00 1993
--- libg++-2.5.3linux.2/libio/iofwrite.c	Mon Feb 14 10:10:02 1994
***************
*** 33,38 ****
--- 33,39 ----
  {
    _IO_size_t request = size*count;
    _IO_size_t written;
+   CHECK_FILE(fp, 0);
    COERCE_FILE(fp);
    if (request == 0)
      return 0;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iogetline.c libg++-2.5.3linux.2/libio/iogetline.c
*** libg++-2.5.3/libio/iogetline.c	Mon Nov 15 16:32:49 1993
--- libg++-2.5.3linux.2/libio/iogetline.c	Thu Jan 27 16:50:06 1994
***************
*** 28,34 ****
  /* Algorithm based on that used by Berkeley pre-4.4 fgets implementation.
  
     Read chars into buf (of size n), until delim is seen.
!    Return number of chars read (at most n-1).
     If extract_delim < 0, leave delimiter unread.
     If extract_delim > 0, insert delim in output. */
  
--- 28,35 ----
  /* Algorithm based on that used by Berkeley pre-4.4 fgets implementation.
  
     Read chars into buf (of size n), until delim is seen.
!    Return number of chars read (at most n).
!    Does not put a terminating '\0' in buf.
     If extract_delim < 0, leave delimiter unread.
     If extract_delim > 0, insert delim in output. */
  
***************
*** 41,52 ****
       int extract_delim;
  {
    register char *ptr = buf;
-   if (n <= 0)
-     return EOF;
-   n--; /* Leave space for final '\0'. */
    do
      {
!       _IO_size_t len = fp->_IO_read_end - fp->_IO_read_ptr;
        char *t;
        if (len <= 0)
  	if (__underflow(fp) == EOF)
--- 42,50 ----
       int extract_delim;
  {
    register char *ptr = buf;
    do
      {
!       _IO_ssize_t len = fp->_IO_read_end - fp->_IO_read_ptr;
        char *t;
        if (len <= 0)
  	if (__underflow(fp) == EOF)
***************
*** 63,74 ****
  	  if (extract_delim >= 0)
  	    {
  	      t++;
- 	      old_len++;
  	      if (extract_delim > 0)
  		len++;
  	    }
  	  memcpy((void*)ptr, (void*)fp->_IO_read_ptr, len);
- 	  ptr[len] = 0;
  	  fp->_IO_read_ptr = t;
  	  return old_len + len;
  	}
--- 61,70 ----
***************
*** 77,82 ****
        ptr += len;
        n -= len;
      } while (n != 0);
-   *ptr = 0;
    return ptr - buf;
  }
--- 73,77 ----
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iogets.c libg++-2.5.3linux.2/libio/iogets.c
*** libg++-2.5.3/libio/iogets.c	Mon Sep 27 17:46:27 1993
--- libg++-2.5.3linux.2/libio/iogets.c	Thu Jan 27 16:50:06 1994
***************
*** 29,36 ****
  _IO_gets(buf)
       char* buf;
  {
!   long count = _IO_getline(_IO_stdin, buf, INT_MAX, '\n', 0);
!   if (count <= 0)
      return NULL;
    return buf;
  }
--- 29,48 ----
  _IO_gets(buf)
       char* buf;
  {
!   _IO_size_t count;
!   int ch = _IO_getc (_IO_stdin);
!   if (ch == EOF)
      return NULL;
+   if (ch == '\n')
+     count = 0;
+   else
+     {
+       buf[0] = (char)ch;
+       count = _IO_getline(_IO_stdin, buf + 1, INT_MAX, '\n', 0) + 1;
+       if (_IO_stdin->_IO_file_flags & _IO_ERR_SEEN)
+ 	return NULL;
+     }
+   buf[count] = 0;
    return buf;
  }
+ 
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/ioignore.c libg++-2.5.3linux.2/libio/ioignore.c
*** libg++-2.5.3/libio/ioignore.c	Wed Nov  3 14:59:53 1993
--- libg++-2.5.3linux.2/libio/ioignore.c	Tue Jan 18 11:23:36 1994
***************
*** 32,38 ****
    register _IO_size_t more = n;
    for (;;)
      {
!       _IO_size_t count = fp->_IO_read_end - fp->_IO_read_ptr;
        if (count > 0)
  	{
  	  if (count > more)
--- 32,38 ----
    register _IO_size_t more = n;
    for (;;)
      {
!       _IO_ssize_t count = fp->_IO_read_end - fp->_IO_read_ptr;
        if (count > 0)
  	{
  	  if (count > more)
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iolibio.h libg++-2.5.3linux.2/libio/iolibio.h
*** libg++-2.5.3/libio/iolibio.h	Fri Nov 26 21:58:50 1993
--- libg++-2.5.3linux.2/libio/iolibio.h	Mon Dec 20 08:54:27 1993
***************
*** 1,31 ****
  #include "libio.h"
  
  /* These emulate stdio functionality, but with a different name
     (_IO_ungetc instead of ungetc), and using _IO_FILE instead of FILE. */
  
! extern int _IO_fclose _PARAMS((_IO_FILE*));
! extern _IO_FILE *_IO_fdopen _PARAMS((int, const char*));
! extern int _IO_fflush _PARAMS((_IO_FILE*));
! extern int _IO_fgetpos _PARAMS((_IO_FILE*, _IO_fpos_t*));
! extern char* _IO_fgets _PARAMS((char*, int, _IO_FILE*));
! extern _IO_FILE *_IO_fopen _PARAMS((const char*, const char*));
! extern int _IO_fprintf _PARAMS((_IO_FILE*, const char*, ...));
! extern int _IO_fputs _PARAMS((const char*, _IO_FILE*));
! extern int _IO_fsetpos _PARAMS((_IO_FILE*, const _IO_fpos_t *));
! extern long int _IO_ftell _PARAMS((_IO_FILE*));
! extern _IO_size_t _IO_fwrite _PARAMS((const void*,
  				      _IO_size_t, _IO_size_t, _IO_FILE*));
! extern char* _IO_gets _PARAMS((char*));
! extern void _IO_perror _PARAMS((const char*));
! extern int _IO_puts _PARAMS((const char*));
! extern int _IO_scanf _PARAMS((const char*, ...));
! extern void _IO_setbuffer _PARAMS((_IO_FILE *, char*, _IO_size_t));
! extern int _IO_setvbuf _PARAMS((_IO_FILE*, char*, int, _IO_size_t));
! extern int _IO_sscanf _PARAMS((const char*, const char*, ...));
! extern int _IO_sprintf _PARAMS((char *, const char*, ...));
! extern int _IO_ungetc _PARAMS((int, _IO_FILE*));
! extern int _IO_vsscanf _PARAMS((const char *, const char *, _IO_va_list));
! extern int _IO_vsprintf _PARAMS((char*, const char*, _IO_va_list));
  #ifndef _IO_pos_BAD
  #define _IO_pos_BAD ((_IO_fpos_t)(-1))
  #endif
--- 1,40 ----
+ #ifndef _IOLIBIO_H
+ #define _IOLIBIO_H
+ 
  #include "libio.h"
  
  /* These emulate stdio functionality, but with a different name
     (_IO_ungetc instead of ungetc), and using _IO_FILE instead of FILE. */
  
! extern int _IO_fclose __P((_IO_FILE*));
! extern _IO_FILE *_IO_fdopen __P((int, const char*));
! extern int _IO_fflush __P((_IO_FILE*));
! extern int _IO_fgetpos __P((_IO_FILE*, _IO_fpos_t*));
! extern char* _IO_fgets __P((char*, int, _IO_FILE*));
! extern _IO_FILE *_IO_fopen __P((const char*, const char*));
! extern int _IO_fprintf __P((_IO_FILE*, const char*, ...));
! extern int _IO_fputs __P((const char*, _IO_FILE*));
! extern _IO_size_t _IO_fread __P((void *,
! 				      _IO_size_t, _IO_size_t, _IO_FILE*));
! extern int _IO_fscanf __P((_IO_FILE *, const char *, ...));
! extern int _IO_fsetpos __P((_IO_FILE*, const _IO_fpos_t *));
! extern long int _IO_ftell __P((_IO_FILE*));
! extern _IO_size_t _IO_fwrite __P((const void*,
  				      _IO_size_t, _IO_size_t, _IO_FILE*));
! extern char* _IO_gets __P((char*));
! extern void _IO_perror __P((const char*));
! extern int _IO_printf  __P((const char *, ...));
! extern int _IO_puts __P((const char*));
! extern int _IO_scanf __P((const char*, ...));
! extern void _IO_setbuffer __P((_IO_FILE *, char*, _IO_size_t));
! extern int _IO_setvbuf __P((_IO_FILE*, char*, int, _IO_size_t));
! extern int _IO_sscanf __P((const char*, const char*, ...));
! extern int _IO_sprintf __P((char *, const char*, ...));
! extern int _IO_ungetc __P((int, _IO_FILE*));
! extern int _IO_vfscanf __P((_IO_FILE *, const char *, _IO_va_list,
! 				int *__errp));
! extern int _IO_vsscanf __P((const char *, const char *, _IO_va_list));
! extern int _IO_vsprintf __P((char*, const char*, _IO_va_list));
  #ifndef _IO_pos_BAD
  #define _IO_pos_BAD ((_IO_fpos_t)(-1))
  #endif
***************
*** 39,46 ****
  #define _IO_freopen(FILENAME, MODE, FP) \
    (_IO_file_close_it(FP), _IO_file_fopen(FP, FILENAME, MODE))
  #define _IO_fileno(FP) ((FP)->_fileno)
! extern _IO_FILE* _IO_popen _PARAMS((const char*, const char*));
  #define _IO_pclose _IO_fclose
  #define _IO_setbuf(_FP, _BUF) _IO_setbuffer(_FP, _BUF, _IO_BUFSIZ)
  #define _IO_setlinebuf(_FP) _IO_setvbuf(_FP, NULL, 1, 0)
  
--- 48,56 ----
  #define _IO_freopen(FILENAME, MODE, FP) \
    (_IO_file_close_it(FP), _IO_file_fopen(FP, FILENAME, MODE))
  #define _IO_fileno(FP) ((FP)->_fileno)
! extern _IO_FILE* _IO_popen __P((const char*, const char*));
  #define _IO_pclose _IO_fclose
  #define _IO_setbuf(_FP, _BUF) _IO_setbuffer(_FP, _BUF, _IO_BUFSIZ)
  #define _IO_setlinebuf(_FP) _IO_setvbuf(_FP, NULL, 1, 0)
  
+ #endif /* _IOLIBIO_H */
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iomanip.h libg++-2.5.3linux.2/libio/iomanip.h
*** libg++-2.5.3/libio/iomanip.h	Fri Oct 22 00:54:27 1993
--- libg++-2.5.3linux.2/libio/iomanip.h	Mon Dec 20 08:54:28 1993
***************
*** 82,88 ****
  template<class TP> class iapp {
      istream& (*_f)(istream&, TP);
  public: 
!     iapp(ostream& (*f)(istream&,TP)) : _f(f) {}
      //
      imanip<TP> operator()(TP a)
         { return imanip<TP>(_f, a); }
--- 82,88 ----
  template<class TP> class iapp {
      istream& (*_f)(istream&, TP);
  public: 
!     iapp(istream& (*f)(istream&,TP)) : _f(f) {}
      //
      imanip<TP> operator()(TP a)
         { return imanip<TP>(_f, a); }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/ioperror.c libg++-2.5.3linux.2/libio/ioperror.c
*** libg++-2.5.3/libio/ioperror.c	Tue Oct  5 22:12:50 1993
--- libg++-2.5.3linux.2/libio/ioperror.c	Mon Dec 20 08:54:28 1993
***************
*** 1,12 ****
  #include "libioP.h"
  #include <errno.h>
- #include <string.h>
  #ifndef errno
  extern int errno;
  #endif
  
  #ifndef _IO_strerror
! extern char* _IO_strerror _PARAMS((int));
  #endif
  
  void
--- 1,58 ----
+ /* Copyright (C) 1991, 1992, 1993 Free Software Foundation, Inc.
+ This file is part of the GNU C Library.
+ 
+ The GNU C Library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public License as
+ published by the Free Software Foundation; either version 2 of the
+ License, or (at your option) any later version.
+ 
+ The GNU C Library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+ 
+ You should have received a copy of the GNU Library General Public
+ License along with the GNU C Library; see the file COPYING.LIB.  If
+ not, write to the Free Software Foundation, Inc., 675 Mass Ave,
+ Cambridge, MA 02139, USA.  */
+ 
+ #include <ansidecl.h>
+ 
  #include "libioP.h"
  #include <errno.h>
  #ifndef errno
  extern int errno;
  #endif
  
+ /* Also glibc? */
+ #ifdef __linux__
+ 
+ /* Print a line on stderr consisting of the text in S, a colon, a space,
+    a message describing the meaning of the contents of `errno' and a newline.
+    If S is NULL or "", the colon and space are omitted.  */
+ void
+ DEFUN(_IO_perror, (s), register CONST char *s)
+ {
+   int errnum = errno;
+   CONST char *colon;
+ 
+   if (s == NULL || *s == '\0')
+     s = colon = "";
+   else
+     colon = ": ";
+ 
+   if (errnum >= 0 && errnum < _sys_nerr)
+     (void) _IO_fprintf(_IO_stderr, "%s%s%s\n", s, colon, _sys_errlist[errnum]);
+   else
+     (void) _IO_fprintf(_IO_stderr, "%s%sUnknown error %d\n", s, colon, errnum);
+ }
+ 
+ #else
+ 
+ #include <string.h>
+ 
  #ifndef _IO_strerror
! extern char* _IO_strerror __P((int));
  #endif
  
  void
***************
*** 20,22 ****
--- 66,70 ----
  
    _IO_fprintf (_IO_stderr, "%s\n", error ? error : "");
  }
+ 
+ #endif
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iopopen.c libg++-2.5.3linux.2/libio/iopopen.c
*** libg++-2.5.3/libio/iopopen.c	Fri Nov 26 18:50:41 1993
--- libg++-2.5.3linux.2/libio/iopopen.c	Mon Dec 20 08:54:28 1993
***************
*** 29,38 ****
  #if _IO_HAVE_SYS_WAIT
  #include <signal.h>
  #include <unistd.h>
- #ifdef __STDC__
- /* This is now provided by gcc's fixproto. */
- #include <stdlib.h>
- #endif
  #include <errno.h>
  #ifndef errno
  extern int errno;
--- 29,34 ----
***************
*** 139,144 ****
--- 135,141 ----
    ((_IO_proc_file*)fp)->_next = proc_file_chain;
    proc_file_chain = (_IO_proc_file*)fp;
  
+   fp->_IO_file_flags |= CLOSED_FILEBUF_FLAGS;
    fp->_IO_file_flags
      = read_or_write | (fp->_IO_file_flags & ~(_IO_NO_READS|_IO_NO_WRITES));
    return fp;
***************
*** 175,194 ****
    int wstatus;
    _IO_proc_file **ptr = &proc_file_chain;
    _IO_pid_t wait_pid;
!   int status = _IO_close(_IO_fileno(fp));
  
    /* Unlink from proc_file_chain. */
!   for ( ; *ptr != NULL; ptr = &(*ptr)->_next)
      {
!       if (*ptr == (_IO_proc_file*)fp)
! 	{
! 	  *ptr = (*ptr)->_next;
! 	  break;
! 	}
      }
  
!   if (status < 0)
!     return status;
    /* POSIX.2 Rationale:  "Some historical implementations either block
       or ignore the signals SIGINT, SIGQUIT, and SIGHUP while waiting
       for the child process to terminate.  Since this behavior is not
--- 172,192 ----
    int wstatus;
    _IO_proc_file **ptr = &proc_file_chain;
    _IO_pid_t wait_pid;
!   int status = -1;
  
    /* Unlink from proc_file_chain. */
!   for (; *ptr; ptr = &((*ptr)->_next))
!   {
!     if (*ptr == (_IO_proc_file*)fp)
      {
!       *ptr = (*ptr)->_next;
!       status = 0;
!       break;
      }
+   }
  
!   if (status < 0 || _IO_close(_IO_fileno(fp)) < 0)
!     return -1;
    /* POSIX.2 Rationale:  "Some historical implementations either block
       or ignore the signals SIGINT, SIGQUIT, and SIGHUP while waiting
       for the child process to terminate.  Since this behavior is not
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/ioprims.c libg++-2.5.3linux.2/libio/ioprims.c
*** libg++-2.5.3/libio/ioprims.c	Tue Aug 17 21:27:04 1993
--- libg++-2.5.3linux.2/libio/ioprims.c	Mon Dec 20 08:54:28 1993
***************
*** 28,34 ****
--- 28,37 ----
     (in which case read would be defined in terms of _IO_read,
     rather than vice versa). */
  
+ #ifndef __linux__
+ 
  #include "libioP.h"
+ #include <unistd.h>
  #include <sys/types.h>
  #include <sys/stat.h>
  
***************
*** 77,79 ****
--- 80,84 ----
  {
    return fstat (fildes, buf);
  }
+ 
+ #endif
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iosetbuffer.c libg++-2.5.3linux.2/libio/iosetbuffer.c
*** libg++-2.5.3/libio/iosetbuffer.c	Mon Oct  4 20:26:21 1993
--- libg++-2.5.3linux.2/libio/iosetbuffer.c	Sun Feb 13 22:31:20 1994
***************
*** 30,35 ****
--- 30,36 ----
       char *buf;
       _IO_size_t size;
  {
+   CHECK_FILE(fp, );
    COERCE_FILE(fp);
    fp->_flags &= ~_IO_LINE_BUF;
    if (buf)
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iosetvbuf.c libg++-2.5.3linux.2/libio/iosetvbuf.c
*** libg++-2.5.3/libio/iosetvbuf.c	Mon Oct  4 20:26:28 1993
--- libg++-2.5.3linux.2/libio/iosetvbuf.c	Sun Feb 13 22:31:30 1994
***************
*** 35,40 ****
--- 35,41 ----
       int mode;
       _IO_size_t size;
  {
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    switch (mode)
      {
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iostrerror.c libg++-2.5.3linux.2/libio/iostrerror.c
*** libg++-2.5.3/libio/iostrerror.c	Mon Oct 11 23:49:53 1993
--- libg++-2.5.3linux.2/libio/iostrerror.c	Mon Dec 20 08:54:29 1993
***************
*** 1,3 ****
--- 1,5 ----
+ #ifndef __linux__
+ 
  /* This should be replaced by whatever namespace-clean
     version of strerror you have available. */
  
***************
*** 9,11 ****
--- 11,15 ----
  {
    return strerror(errnum);
  }
+ 
+ #endif
